/**
 * OpenStax Highlights API
 * The highlights API for OpenStax.  Requests to this API should include `application/json` in the `Accept` header.  The desired API version is specified in the request URL, e.g. `[domain]/highlights/api/v0/highlights`. While the API does support a default version, that version will change over time and therefore should not be used in production code!
 *
 * The version of the OpenAPI document: 0.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface HighlightUpdate
 */
export interface HighlightUpdate {
    /**
     * The new name of the highlight color.  Corresponding RGB values for different states (e.g. focused, passive) are maintained in the client.
     * @type {string}
     * @memberof HighlightUpdate
     */
    color?: HighlightUpdateColorEnum;
    /**
     * The new note for the highlight (replaces existing note).
     * @type {string}
     * @memberof HighlightUpdate
     */
    annotation?: string;
}
export declare function HighlightUpdateFromJSON(json: any): HighlightUpdate;
export declare function HighlightUpdateFromJSONTyped(json: any, ignoreDiscriminator: boolean): HighlightUpdate;
export declare function HighlightUpdateToJSON(value?: HighlightUpdate | null): any;
/**
* @export
* @enum {string}
*/
export declare enum HighlightUpdateColorEnum {
    Yellow = "yellow",
    Green = "green",
    Blue = "blue",
    Purple = "purple",
    Pink = "pink"
}
