/**
 * OpenStax Highlights API
 * The highlights API for OpenStax.  Requests to this API should include `application/json` in the `Accept` header.  The desired API version is specified in the request URL, e.g. `[domain]/highlights/api/v0/highlights`. While the API does support a default version, that version will change over time and therefore should not be used in production code!
 *
 * The version of the OpenAPI document: 0.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { InfoData } from './';
/**
 *
 * @export
 * @interface InfoResults
 */
export interface InfoResults {
    /**
     * How long the request took (ms)
     * @type {number}
     * @memberof InfoResults
     */
    readonly overallTookMs?: number;
    /**
     * Current version of Postgres
     * @type {string}
     * @memberof InfoResults
     */
    readonly postgresVersion?: string;
    /**
     * Name of deployed environment
     * @type {string}
     * @memberof InfoResults
     */
    readonly envName?: string;
    /**
     * Accounts environment name
     * @type {string}
     * @memberof InfoResults
     */
    readonly accountsEnvName?: string;
    /**
     * Amazon machine image id
     * @type {string}
     * @memberof InfoResults
     */
    readonly amiId?: string;
    /**
     * Git sha
     * @type {string}
     * @memberof InfoResults
     */
    readonly gitSha?: string;
    /**
     *
     * @type {InfoData}
     * @memberof InfoResults
     */
    data?: InfoData;
}
export declare function InfoResultsFromJSON(json: any): InfoResults;
export declare function InfoResultsFromJSONTyped(json: any, ignoreDiscriminator: boolean): InfoResults;
export declare function InfoResultsToJSON(value?: InfoResults | null): any;
