/* tslint:disable */
/* eslint-disable */
/**
 * OpenStax Highlights API
 * The highlights API for OpenStax.  Requests to this API should include `application/json` in the `Accept` header.  The desired API version is specified in the request URL, e.g. `[domain]/highlights/api/v0/highlights`. While the API does support a default version, that version will change over time and therefore should not be used in production code! 
 *
 * The version of the OpenAPI document: 0.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import * as runtime from '../runtime';
import {
    Highlight,
    HighlightFromJSON,
    HighlightToJSON,
    HighlightUpdate,
    HighlightUpdateFromJSON,
    HighlightUpdateToJSON,
    Highlights,
    HighlightsFromJSON,
    HighlightsToJSON,
    HighlightsSummary,
    HighlightsSummaryFromJSON,
    HighlightsSummaryToJSON,
    NewHighlight,
    NewHighlightFromJSON,
    NewHighlightToJSON,
} from '../models';

export interface AddHighlightRequest {
    highlight: NewHighlight;
}

export interface DeleteHighlightRequest {
    id: string;
}

export interface GetHighlightRequest {
    id: string;
}

export interface GetHighlightsRequest {
    sourceType?: GetHighlightsSourceTypeEnum;
    scopeId?: string;
    sets?: Array<GetHighlightsSetsEnum>;
    sourceIds?: Array<string>;
    colors?: Array<GetHighlightsColorsEnum>;
    page?: number;
    perPage?: number;
}

export interface GetHighlightsSummaryRequest {
    sourceType?: GetHighlightsSummarySourceTypeEnum;
    scopeId?: string;
    sets?: Array<GetHighlightsSummarySetsEnum>;
    colors?: Array<GetHighlightsSummaryColorsEnum>;
}

export interface UpdateHighlightRequest {
    id: string;
    highlight: HighlightUpdate;
}

/**
 * 
 */
export class HighlightsApi extends runtime.BaseAPI {

    /**
     * Add a highlight with an optional note
     * Add a highlight
     */
    async addHighlightRaw(requestParameters: AddHighlightRequest): Promise<runtime.ApiResponse<Highlight>> {
        if (requestParameters.highlight === null || requestParameters.highlight === undefined) {
            throw new runtime.RequiredError('highlight','Required parameter requestParameters.highlight was null or undefined when calling addHighlight.');
        }

        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/highlights`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: NewHighlightToJSON(requestParameters.highlight),
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => HighlightFromJSON(jsonValue));
    }

    /**
     * Add a highlight with an optional note
     * Add a highlight
     */
    async addHighlight(requestParameters: AddHighlightRequest): Promise<Highlight> {
        const response = await this.addHighlightRaw(requestParameters);
        return await response.value();
    }

    /**
     * Delete a highlight. Can only be done by the owner of the highlight.
     * Delete a highlight
     */
    async deleteHighlightRaw(requestParameters: DeleteHighlightRequest): Promise<runtime.ApiResponse<void>> {
        if (requestParameters.id === null || requestParameters.id === undefined) {
            throw new runtime.RequiredError('id','Required parameter requestParameters.id was null or undefined when calling deleteHighlight.');
        }

        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        const response = await this.request({
            path: `/highlights/{id}`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
            method: 'DELETE',
            headers: headerParameters,
            query: queryParameters,
        });

        return new runtime.VoidApiResponse(response);
    }

    /**
     * Delete a highlight. Can only be done by the owner of the highlight.
     * Delete a highlight
     */
    async deleteHighlight(requestParameters: DeleteHighlightRequest): Promise<void> {
        await this.deleteHighlightRaw(requestParameters);
    }

    /**
     * Get a highlight without its annotation data.
     * Get a highlight without its annotation data.
     */
    async getHighlightRaw(requestParameters: GetHighlightRequest): Promise<runtime.ApiResponse<Highlight>> {
        if (requestParameters.id === null || requestParameters.id === undefined) {
            throw new runtime.RequiredError('id','Required parameter requestParameters.id was null or undefined when calling getHighlight.');
        }

        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        const response = await this.request({
            path: `/highlights/{id}`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => HighlightFromJSON(jsonValue));
    }

    /**
     * Get a highlight without its annotation data.
     * Get a highlight without its annotation data.
     */
    async getHighlight(requestParameters: GetHighlightRequest): Promise<Highlight> {
        const response = await this.getHighlightRaw(requestParameters);
        return await response.value();
    }

    /**
     * Get filtered highlights belonging to the calling user.  Highlights can be filtered thru query parameters:  source_type, scope_id, source_ids, and color.  Results are paginated and ordered.  When source_ids are specified, the order is order within the sources.  When source_ids are not specified, the order is by creation time.  Example call:   /api/v0/highlights?source_type=openstax_page&scope_id=123&color=yellow 
     * Get filtered highlights
     */
    async getHighlightsRaw(requestParameters: GetHighlightsRequest): Promise<runtime.ApiResponse<Highlights>> {
        const queryParameters: any = {};

        if (requestParameters.sourceType !== undefined) {
            queryParameters['source_type'] = requestParameters.sourceType;
        }

        if (requestParameters.scopeId !== undefined) {
            queryParameters['scope_id'] = requestParameters.scopeId;
        }

        if (requestParameters.sets) {
            queryParameters['sets'] = requestParameters.sets.join(runtime.COLLECTION_FORMATS["csv"]);
        }

        if (requestParameters.sourceIds) {
            queryParameters['source_ids'] = requestParameters.sourceIds.join(runtime.COLLECTION_FORMATS["csv"]);
        }

        if (requestParameters.colors) {
            queryParameters['colors'] = requestParameters.colors.join(runtime.COLLECTION_FORMATS["csv"]);
        }

        if (requestParameters.page !== undefined) {
            queryParameters['page'] = requestParameters.page;
        }

        if (requestParameters.perPage !== undefined) {
            queryParameters['per_page'] = requestParameters.perPage;
        }

        const headerParameters: runtime.HTTPHeaders = {};

        const response = await this.request({
            path: `/highlights`,
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => HighlightsFromJSON(jsonValue));
    }

    /**
     * Get filtered highlights belonging to the calling user.  Highlights can be filtered thru query parameters:  source_type, scope_id, source_ids, and color.  Results are paginated and ordered.  When source_ids are specified, the order is order within the sources.  When source_ids are not specified, the order is by creation time.  Example call:   /api/v0/highlights?source_type=openstax_page&scope_id=123&color=yellow 
     * Get filtered highlights
     */
    async getHighlights(requestParameters: GetHighlightsRequest): Promise<Highlights> {
        const response = await this.getHighlightsRaw(requestParameters);
        return await response.value();
    }

    /**
     * Get summary of highlights (counts per source, etc) belonging to the calling user.  Highlights can be filtered thru query parameters:  source_type, scope_id, and color.  Results are not paginated.  Example call:   /api/v0/highlights/summary?source_type=openstax_page&scope_id=123&color=#ff0000 
     * Get summary of highlights (counts per source, etc)
     */
    async getHighlightsSummaryRaw(requestParameters: GetHighlightsSummaryRequest): Promise<runtime.ApiResponse<HighlightsSummary>> {
        const queryParameters: any = {};

        if (requestParameters.sourceType !== undefined) {
            queryParameters['source_type'] = requestParameters.sourceType;
        }

        if (requestParameters.scopeId !== undefined) {
            queryParameters['scope_id'] = requestParameters.scopeId;
        }

        if (requestParameters.sets) {
            queryParameters['sets'] = requestParameters.sets.join(runtime.COLLECTION_FORMATS["csv"]);
        }

        if (requestParameters.colors) {
            queryParameters['colors'] = requestParameters.colors.join(runtime.COLLECTION_FORMATS["csv"]);
        }

        const headerParameters: runtime.HTTPHeaders = {};

        const response = await this.request({
            path: `/highlights/summary`,
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => HighlightsSummaryFromJSON(jsonValue));
    }

    /**
     * Get summary of highlights (counts per source, etc) belonging to the calling user.  Highlights can be filtered thru query parameters:  source_type, scope_id, and color.  Results are not paginated.  Example call:   /api/v0/highlights/summary?source_type=openstax_page&scope_id=123&color=#ff0000 
     * Get summary of highlights (counts per source, etc)
     */
    async getHighlightsSummary(requestParameters: GetHighlightsSummaryRequest): Promise<HighlightsSummary> {
        const response = await this.getHighlightsSummaryRaw(requestParameters);
        return await response.value();
    }

    /**
     * Update a highlight
     * Update a highlight
     */
    async updateHighlightRaw(requestParameters: UpdateHighlightRequest): Promise<runtime.ApiResponse<Highlight>> {
        if (requestParameters.id === null || requestParameters.id === undefined) {
            throw new runtime.RequiredError('id','Required parameter requestParameters.id was null or undefined when calling updateHighlight.');
        }

        if (requestParameters.highlight === null || requestParameters.highlight === undefined) {
            throw new runtime.RequiredError('highlight','Required parameter requestParameters.highlight was null or undefined when calling updateHighlight.');
        }

        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/highlights/{id}`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
            method: 'PUT',
            headers: headerParameters,
            query: queryParameters,
            body: HighlightUpdateToJSON(requestParameters.highlight),
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => HighlightFromJSON(jsonValue));
    }

    /**
     * Update a highlight
     * Update a highlight
     */
    async updateHighlight(requestParameters: UpdateHighlightRequest): Promise<Highlight> {
        const response = await this.updateHighlightRaw(requestParameters);
        return await response.value();
    }

}

/**
    * @export
    * @enum {string}
    */
export enum GetHighlightsSourceTypeEnum {
    OpenstaxPage = 'openstax_page'
}
/**
    * @export
    * @enum {string}
    */
export enum GetHighlightsSetsEnum {
    Userme = 'user:me',
    Curatedopenstax = 'curated:openstax'
}
/**
    * @export
    * @enum {string}
    */
export enum GetHighlightsColorsEnum {
    Yellow = 'yellow',
    Green = 'green',
    Blue = 'blue',
    Purple = 'purple',
    Pink = 'pink'
}
/**
    * @export
    * @enum {string}
    */
export enum GetHighlightsSummarySourceTypeEnum {
    OpenstaxPage = 'openstax_page'
}
/**
    * @export
    * @enum {string}
    */
export enum GetHighlightsSummarySetsEnum {
    Userme = 'user:me',
    Curatedopenstax = 'curated:openstax'
}
/**
    * @export
    * @enum {string}
    */
export enum GetHighlightsSummaryColorsEnum {
    Yellow = 'yellow',
    Green = 'green',
    Blue = 'blue',
    Purple = 'purple',
    Pink = 'pink'
}
