/* tslint:disable */
/* eslint-disable */
/**
 * OpenStax Highlights API
 * The highlights API for OpenStax.  Requests to this API should include `application/json` in the `Accept` header.  The desired API version is specified in the request URL, e.g. `[domain]/highlights/api/v0/highlights`. While the API does support a default version, that version will change over time and therefore should not be used in production code! 
 *
 * The version of the OpenAPI document: 0.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface GetHighlightsParameters
 */
export interface GetHighlightsParameters {
    /**
     * Limits results to those highlights made in sources of this type.
     * @type {string}
     * @memberof GetHighlightsParameters
     */
    sourceType: GetHighlightsParametersSourceTypeEnum;
    /**
     * Limits results to the source document container in which the highlight was made.  For openstax_page source_types, this is a versionless book UUID. If this is not specified, results across scopes will be returned, meaning the order of the results will not be meaningful.
     * @type {string}
     * @memberof GetHighlightsParameters
     */
    scopeId?: string;
    /**
     * One or more sets to load data from; default is "user:me"
     * @type {Array<string>}
     * @memberof GetHighlightsParameters
     */
    sets?: Array<GetHighlightsParametersSetsEnum>;
    /**
     * One or more source IDs; query results will contain highlights ordered by the order of these source IDs and ordered within each source.  If parameter is an empty array, no results will be returned.  If the parameter is not provided, all highlights under the scope will be returned.
     * @type {Array<string>}
     * @memberof GetHighlightsParameters
     */
    sourceIds?: Array<string>;
    /**
     * Limits results to these highlight colors.
     * @type {Array<string>}
     * @memberof GetHighlightsParameters
     */
    colors?: Array<GetHighlightsParametersColorsEnum>;
    /**
     * The page number of paginated results, one-indexed.
     * @type {number}
     * @memberof GetHighlightsParameters
     */
    page?: number;
    /**
     * The number of highlights per page for paginated results.
     * @type {number}
     * @memberof GetHighlightsParameters
     */
    perPage?: number;
}

export function GetHighlightsParametersFromJSON(json: any): GetHighlightsParameters {
    return GetHighlightsParametersFromJSONTyped(json, false);
}

export function GetHighlightsParametersFromJSONTyped(json: any, ignoreDiscriminator: boolean): GetHighlightsParameters {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'sourceType': json['source_type'],
        'scopeId': !exists(json, 'scope_id') ? undefined : json['scope_id'],
        'sets': !exists(json, 'sets') ? undefined : json['sets'],
        'sourceIds': !exists(json, 'source_ids') ? undefined : json['source_ids'],
        'colors': !exists(json, 'colors') ? undefined : json['colors'],
        'page': !exists(json, 'page') ? undefined : json['page'],
        'perPage': !exists(json, 'per_page') ? undefined : json['per_page'],
    };
}

export function GetHighlightsParametersToJSON(value?: GetHighlightsParameters | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'source_type': value.sourceType,
        'scope_id': value.scopeId,
        'sets': value.sets,
        'source_ids': value.sourceIds,
        'colors': value.colors,
        'page': value.page,
        'per_page': value.perPage,
    };
}

/**
* @export
* @enum {string}
*/
export enum GetHighlightsParametersSourceTypeEnum {
    OpenstaxPage = 'openstax_page'
}
/**
* @export
* @enum {string}
*/
export enum GetHighlightsParametersSetsEnum {
    Userme = 'user:me',
    Curatedopenstax = 'curated:openstax'
}
/**
* @export
* @enum {string}
*/
export enum GetHighlightsParametersColorsEnum {
    Yellow = 'yellow',
    Green = 'green',
    Blue = 'blue',
    Purple = 'purple',
    Pink = 'pink'
}


