/* tslint:disable */
/* eslint-disable */
/**
 * OpenStax Highlights API
 * The highlights API for OpenStax.  Requests to this API should include `application/json` in the `Accept` header.  The desired API version is specified in the request URL, e.g. `[domain]/highlights/api/v0/highlights`. While the API does support a default version, that version will change over time and therefore should not be used in production code! 
 *
 * The version of the OpenAPI document: 0.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface GetHighlightsSummaryParameters
 */
export interface GetHighlightsSummaryParameters {
    /**
     * Limits summary to those highlights made in sources of this type.
     * @type {string}
     * @memberof GetHighlightsSummaryParameters
     */
    sourceType: GetHighlightsSummaryParametersSourceTypeEnum;
    /**
     * Limits summary to the source document container in which the highlights were made.  For openstax_page source_types, this is a versionless book UUID.
     * @type {string}
     * @memberof GetHighlightsSummaryParameters
     */
    scopeId?: string;
    /**
     * One or more sets to load data from; default is "user:me"
     * @type {Array<string>}
     * @memberof GetHighlightsSummaryParameters
     */
    sets?: Array<GetHighlightsSummaryParametersSetsEnum>;
    /**
     * Limits results to these highlight colors.
     * @type {Array<string>}
     * @memberof GetHighlightsSummaryParameters
     */
    colors?: Array<GetHighlightsSummaryParametersColorsEnum>;
}

export function GetHighlightsSummaryParametersFromJSON(json: any): GetHighlightsSummaryParameters {
    return GetHighlightsSummaryParametersFromJSONTyped(json, false);
}

export function GetHighlightsSummaryParametersFromJSONTyped(json: any, ignoreDiscriminator: boolean): GetHighlightsSummaryParameters {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'sourceType': json['source_type'],
        'scopeId': !exists(json, 'scope_id') ? undefined : json['scope_id'],
        'sets': !exists(json, 'sets') ? undefined : json['sets'],
        'colors': !exists(json, 'colors') ? undefined : json['colors'],
    };
}

export function GetHighlightsSummaryParametersToJSON(value?: GetHighlightsSummaryParameters | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'source_type': value.sourceType,
        'scope_id': value.scopeId,
        'sets': value.sets,
        'colors': value.colors,
    };
}

/**
* @export
* @enum {string}
*/
export enum GetHighlightsSummaryParametersSourceTypeEnum {
    OpenstaxPage = 'openstax_page'
}
/**
* @export
* @enum {string}
*/
export enum GetHighlightsSummaryParametersSetsEnum {
    Userme = 'user:me',
    Curatedopenstax = 'curated:openstax'
}
/**
* @export
* @enum {string}
*/
export enum GetHighlightsSummaryParametersColorsEnum {
    Yellow = 'yellow',
    Green = 'green',
    Blue = 'blue',
    Purple = 'purple',
    Pink = 'pink'
}


