/* tslint:disable */
/* eslint-disable */
/**
 * OpenStax Highlights API
 * The highlights API for OpenStax.  Requests to this API should include `application/json` in the `Accept` header.  The desired API version is specified in the request URL, e.g. `[domain]/highlights/api/v0/highlights`. While the API does support a default version, that version will change over time and therefore should not be used in production code! 
 *
 * The version of the OpenAPI document: 0.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    ColorCount,
    ColorCountFromJSON,
    ColorCountFromJSONTyped,
    ColorCountToJSON,
} from './';

/**
 * 
 * @export
 * @interface HighlightsSummary
 */
export interface HighlightsSummary {
    /**
     * Map of source ID to number of highlights by color in that source
     * @type {{ [key: string]: ColorCount; }}
     * @memberof HighlightsSummary
     */
    countsPerSource?: { [key: string]: ColorCount; };
}

export function HighlightsSummaryFromJSON(json: any): HighlightsSummary {
    return HighlightsSummaryFromJSONTyped(json, false);
}

export function HighlightsSummaryFromJSONTyped(json: any, ignoreDiscriminator: boolean): HighlightsSummary {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'countsPerSource': !exists(json, 'counts_per_source') ? undefined : (mapValues(json['counts_per_source'], ColorCountFromJSON)),
    };
}

export function HighlightsSummaryToJSON(value?: HighlightsSummary | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'counts_per_source': value.countsPerSource === undefined ? undefined : (mapValues(value.countsPerSource, ColorCountToJSON)),
    };
}


