/* tslint:disable */
/* eslint-disable */
/**
 * OpenStax Highlights API
 * The highlights API for OpenStax.  Requests to this API should include `application/json` in the `Accept` header.  The desired API version is specified in the request URL, e.g. `[domain]/highlights/api/v0/highlights`. While the API does support a default version, that version will change over time and therefore should not be used in production code! 
 *
 * The version of the OpenAPI document: 0.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface InfoData
 */
export interface InfoData {
    /**
     * The total number of notes/annotations
     * @type {number}
     * @memberof InfoData
     */
    totalNotes?: number;
    /**
     * The number of users with notes
     * @type {number}
     * @memberof InfoData
     */
    numUsersWithNotes?: number;
    /**
     * The average length (chars) of a note
     * @type {number}
     * @memberof InfoData
     */
    avgNoteLength?: number;
    /**
     * The median length (chars) of a note
     * @type {number}
     * @memberof InfoData
     */
    medianNoteLength?: number;
    /**
     * The max length (chars) of a note for any user
     * @type {number}
     * @memberof InfoData
     */
    maxNoteLength?: number;
    /**
     * The total number of highlights
     * @type {number}
     * @memberof InfoData
     */
    totalHighlights?: number;
    /**
     * The number of users with highlights
     * @type {number}
     * @memberof InfoData
     */
    numUsersWithHighlights?: number;
    /**
     * The average number of highlights per user
     * @type {number}
     * @memberof InfoData
     */
    avgHighlightsPerUser?: number;
    /**
     * The median number of highlights per user
     * @type {number}
     * @memberof InfoData
     */
    medianHighlightsPerUser?: number;
    /**
     * The max number of highlights used by any one user
     * @type {number}
     * @memberof InfoData
     */
    maxNumHighlightsAnyUser?: number;
    /**
     * The number of users that have greater than 200 highlights on any page
     * @type {number}
     * @memberof InfoData
     */
    numUsersGt200HighlightsPerPage?: number;
    /**
     * The number of users that have greater than 10 highlights
     * @type {number}
     * @memberof InfoData
     */
    numUsersGt10Highlights?: number;
    /**
     * The number of users that have greater than 50 highlights
     * @type {number}
     * @memberof InfoData
     */
    numUsersGt50Highlights?: number;
    /**
     * The total number of users
     * @type {number}
     * @memberof InfoData
     */
    totalUsers?: number;
    /**
     * The precalculated start time
     * @type {string}
     * @memberof InfoData
     */
    genStartedAt?: string;
    /**
     * The precalculated end time
     * @type {string}
     * @memberof InfoData
     */
    genEndedAt?: string;
}

export function InfoDataFromJSON(json: any): InfoData {
    return InfoDataFromJSONTyped(json, false);
}

export function InfoDataFromJSONTyped(json: any, ignoreDiscriminator: boolean): InfoData {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'totalNotes': !exists(json, 'total_notes') ? undefined : json['total_notes'],
        'numUsersWithNotes': !exists(json, 'num_users_with_notes') ? undefined : json['num_users_with_notes'],
        'avgNoteLength': !exists(json, 'avg_note_length') ? undefined : json['avg_note_length'],
        'medianNoteLength': !exists(json, 'median_note_length') ? undefined : json['median_note_length'],
        'maxNoteLength': !exists(json, 'max_note_length') ? undefined : json['max_note_length'],
        'totalHighlights': !exists(json, 'total_highlights') ? undefined : json['total_highlights'],
        'numUsersWithHighlights': !exists(json, 'num_users_with_highlights') ? undefined : json['num_users_with_highlights'],
        'avgHighlightsPerUser': !exists(json, 'avg_highlights_per_user') ? undefined : json['avg_highlights_per_user'],
        'medianHighlightsPerUser': !exists(json, 'median_highlights_per_user') ? undefined : json['median_highlights_per_user'],
        'maxNumHighlightsAnyUser': !exists(json, 'max_num_highlights_any_user') ? undefined : json['max_num_highlights_any_user'],
        'numUsersGt200HighlightsPerPage': !exists(json, 'num_users_gt_200_highlights_per_page') ? undefined : json['num_users_gt_200_highlights_per_page'],
        'numUsersGt10Highlights': !exists(json, 'num_users_gt_10_highlights') ? undefined : json['num_users_gt_10_highlights'],
        'numUsersGt50Highlights': !exists(json, 'num_users_gt_50_highlights') ? undefined : json['num_users_gt_50_highlights'],
        'totalUsers': !exists(json, 'total_users') ? undefined : json['total_users'],
        'genStartedAt': !exists(json, 'gen_started_at') ? undefined : json['gen_started_at'],
        'genEndedAt': !exists(json, 'gen_ended_at') ? undefined : json['gen_ended_at'],
    };
}

export function InfoDataToJSON(value?: InfoData | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'total_notes': value.totalNotes,
        'num_users_with_notes': value.numUsersWithNotes,
        'avg_note_length': value.avgNoteLength,
        'median_note_length': value.medianNoteLength,
        'max_note_length': value.maxNoteLength,
        'total_highlights': value.totalHighlights,
        'num_users_with_highlights': value.numUsersWithHighlights,
        'avg_highlights_per_user': value.avgHighlightsPerUser,
        'median_highlights_per_user': value.medianHighlightsPerUser,
        'max_num_highlights_any_user': value.maxNumHighlightsAnyUser,
        'num_users_gt_200_highlights_per_page': value.numUsersGt200HighlightsPerPage,
        'num_users_gt_10_highlights': value.numUsersGt10Highlights,
        'num_users_gt_50_highlights': value.numUsersGt50Highlights,
        'total_users': value.totalUsers,
        'gen_started_at': value.genStartedAt,
        'gen_ended_at': value.genEndedAt,
    };
}


