/* tslint:disable */
/* eslint-disable */
/**
 * OpenStax Highlights API
 * The highlights API for OpenStax.  Requests to this API should include `application/json` in the `Accept` header.  The desired API version is specified in the request URL, e.g. `[domain]/highlights/api/v0/highlights`. While the API does support a default version, that version will change over time and therefore should not be used in production code! 
 *
 * The version of the OpenAPI document: 0.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    InfoData,
    InfoDataFromJSON,
    InfoDataFromJSONTyped,
    InfoDataToJSON,
} from './';

/**
 * 
 * @export
 * @interface InfoResults
 */
export interface InfoResults {
    /**
     * How long the request took (ms)
     * @type {number}
     * @memberof InfoResults
     */
    readonly overallTookMs?: number;
    /**
     * Current version of Postgres
     * @type {string}
     * @memberof InfoResults
     */
    readonly postgresVersion?: string;
    /**
     * Name of deployed environment
     * @type {string}
     * @memberof InfoResults
     */
    readonly envName?: string;
    /**
     * Accounts environment name
     * @type {string}
     * @memberof InfoResults
     */
    readonly accountsEnvName?: string;
    /**
     * Amazon machine image id
     * @type {string}
     * @memberof InfoResults
     */
    readonly amiId?: string;
    /**
     * Git sha
     * @type {string}
     * @memberof InfoResults
     */
    readonly gitSha?: string;
    /**
     * 
     * @type {InfoData}
     * @memberof InfoResults
     */
    data?: InfoData;
}

export function InfoResultsFromJSON(json: any): InfoResults {
    return InfoResultsFromJSONTyped(json, false);
}

export function InfoResultsFromJSONTyped(json: any, ignoreDiscriminator: boolean): InfoResults {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'overallTookMs': !exists(json, 'overall_took_ms') ? undefined : json['overall_took_ms'],
        'postgresVersion': !exists(json, 'postgres_version') ? undefined : json['postgres_version'],
        'envName': !exists(json, 'env_name') ? undefined : json['env_name'],
        'accountsEnvName': !exists(json, 'accounts_env_name') ? undefined : json['accounts_env_name'],
        'amiId': !exists(json, 'ami_id') ? undefined : json['ami_id'],
        'gitSha': !exists(json, 'git_sha') ? undefined : json['git_sha'],
        'data': !exists(json, 'data') ? undefined : InfoDataFromJSON(json['data']),
    };
}

export function InfoResultsToJSON(value?: InfoResults | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'data': InfoDataToJSON(value.data),
    };
}


